% To simplify for teaching, remove all cubes identity but Left / Rignt TiltSmallAngleNearHorizontal
% The purpose for drawing bars with matrix instead of Screen('DrawLine') is
% to easily draw some other complex patterns in the future.


%--- Nov. 21, 2007, added CubeL, CubeT, CubeLeftT, CubeRightT, in order to do
%searching T among Ls.
%--- Oct. 20, 2007, added a CubeCircle, to make a circle possible, in order
%to do ocular cueing experiment.
%
% This was written by Zhaoping 
% June 2007
% This small code is used by the MainCode program

%% stimulus grid parameter

% A choice of grid numbers and cube/bar size.
params.stim.NbX = 30; 
params.stim.NbY = 22;  
SizeCube = round(params.stim.sizeCubeDeg * PixelPerDegreeVA);  
Sizebar = round(params.stim.sizeBarDeg * PixelPerDegreeVA);  
Widthbar = params.stim.widthBarDeg * PixelPerDegreeVA;
AnchorpiontPix = round(params.stim.anchorPointDeg * PixelPerDegreeVA);

%--- The angle of the bar from vertical or horizontal, such that the orientation contrast will be 2* Angle.
params.stim.angleDeg = 25; 

% left and right tilted bars
params.stim.NitemTypes = 2;

%--- the maximum pixel value allocated to stimulus.
maxValue = params.screen.FOR_COLOR;
%--- for half or whole strength bar stimulus, half is used for binocular
%stimulus while whole is used for monocular stimulus 
params.stim.HALF_STRENGTH =0.5; params.stim.WHOLE_STRENGTH = 1; 

%%
% Get the basic Horizontal bars------------------------------
x=linspace(-1,1,Sizebar);
y=linspace(-1,1,Sizebar);
[X Y]=meshgrid(x,y);
% bar=cos(X).^300;
bar = abs(X)<(Widthbar/Sizebar/2);

CubeVertical = bar;
% Normalize the CubeVer to the maxValue we set
CubeVertical=maxValue*CubeVertical/max(max(CubeVertical)); 

%--- 
%Get the tilted bars-------------------------------------------------
CubeTilted= imrotate(CubeVertical,params.stim.angleDeg,'bicubic','crop');
CubeTilted = (CubeTilted> 0).*CubeTilted;
totallum = sum(sum(CubeVertical));
% itterate 4 times to optimize the stimulus
for iiter = 1:4
    totallumTarget = sum(sum(CubeTilted));
    CubeTilted = totallum/totallumTarget*CubeTilted;
    temMatrix = CubeTilted;
    CubeTilted = (temMatrix> maxValue).*ones(Sizebar)*maxValue + (temMatrix<=maxValue).*temMatrix;
end

%--- small angle left and right tilted bar
CubeLeftTiltSmallAngle = CubeTilted;   

% Transpose to make it near horizontal
CubeLeftTiltSmallAngleNearHorizontal = CubeLeftTiltSmallAngle';
% flip horizontally to make right tilted bar
CubeRightTiltSmallAngleNearHorizontal = CubeLeftTiltSmallAngleNearHorizontal(Sizebar:-1:1, :);

AllCubes = zeros(params.stim.NitemTypes, Sizebar, Sizebar);
AllCubes(1, :,:) = CubeLeftTiltSmallAngleNearHorizontal;
AllCubes(2, :,:) = CubeRightTiltSmallAngleNearHorizontal;
